package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class B_MaxTest extends ExaminationTestDefaults {
    static final public double PRECISION = 1.E-12;

    @Test
    @Marking(points = 15)
    public void test() {
        assertMaximum(12, 4, 3, '*');
        assertMaximum(5, 2, -3, '-');
        assertMaximum(5.1, 0.1, 5, '+');
        assertMaximum(35, 7, 0.2, '/');
        assertMaximum(-1.4,-7, 0.2, '*');
        assertMaximum(4,2, 2, '+', '*');
    }

    private static void assertMaximum(final double expected, final double first, final double second, char ... operation) {

        final StringBuilder errMsg = new StringBuilder("Expected maximum is ").append(expected).append(" == ").
                append(first).append(" ").append(join(operation)).append(" ");

        if (second < 0) {
            errMsg.append("(" + second + ")");
        } else {
            errMsg.append(second);
        }
        Assert.assertEquals(errMsg.toString(), expected, B_Max.getBasicCalculationMax(first, second), PRECISION);
    }

    private static String join(char[] operations) {
        if (1 == operations.length) {
            return Character.toString(operations[0]);
        } else {
            StringBuilder ret = new StringBuilder("{") .append(operations[0]);
            for (int i = 1; i < operations.length; i++) {
                ret.append(" or ").append(operations[i]);
            }
            return ret.append('}').toString();
        }
    }
}
