package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class C_WebUrlTest extends ExaminationTestDefaults {

    static public final String DEBUG_TEST_HINT = "Wanna set a breakpoint to start debugging?";

    public static final Logger log = LogManager.getLogger();

    static private final String dnsNames[] = {
            "www.der-postillon.com", "www.duh.de", "www.amnesty.org"
    };

    @Test
    @Marking(points = 14)
    public void testNames() {

        for(final String dns: dnsNames) {
            test("http://" + dns, dns, false);
            test("https://" + dns, dns, true);

            test("http://" + dns, "http://" + dns, false);
            test("http://" + dns, "http://" + dns, true);

            test("https://" + dns, "https://" + dns, false);
            test("https://" + dns, "https://" + dns, true);
        }
    }
    static private void test(final String expectedUrl, final String inputUrl, final boolean tlsSupport) {

        final String actualUrl = C_WebUrl.amendWebAddress(inputUrl, tlsSupport);

        if (!expectedUrl.equals(actualUrl)) {
            final String msg = DEBUG_TEST_HINT;

            Assert.assertEquals(msg, expectedUrl, actualUrl);
        }
    }
}
